#!/usr/bin/perl
# indexsoft mysql backups manager
# http://www.indexsoft.com

$|++;
$VER = '2.2 shareware';
$ENV{'DOCUMENT_ROOT'}?($cron = 0):($cron = 1);
$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
$configfile = $0;
$configfile =~ s/(backupsmanager.cgi|backup~1.cgi)$//gi;
chop $configfile;
$configfile = '.' if !$configfile;
push (@INC, $configfile);
push (@INC, "$configfile$DirSeparator".'modules');
$configfile = "$configfile$DirSeparator".'backupsmanager.pm';
eval('use SendMail;');
$sendmailerror = $@;
eval('use Net::FTP;');
$ftperror = $@;
&ReadParameters() if !$cron;
if (($P{'todo'} eq 'saveconfig') and $P{'cfgfilecontent'})
{
	open(FILE, ">$configfile") || ($notsaved = 1);
	binmode('FILE');
	print FILE $P{'cfgfilecontent'};
	close FILE;
}
eval('require "$configfile";');
$configerror = $@;
&ReadArgv() if $cron;
$nowtime = time;
$Old = $OldBackups*86400;
&DefineParams($P{'db'});

if ($P{'todo'} eq 'dumpanddownload' and $mySQLDBName)
{
	print "Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-Disposition: attachment; filename=".&TextDate(time).".sql\nContent-type: application/binary\n\n";
	binmode('STDOUT'); system "$iDumpDBCommand";
	exit;
}
elsif (($P{'todo'} eq 'downloadfile') and $P{'file'})
{
	print "Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-Disposition: attachment; filename=$P{'file'}\nContent-type: application/binary\n\n";
	$CHUNK_SIZE = 4096;
	open(IN, "$iDBDumpsDir$DirSeparator$P{'file'}");
	binmode('IN'); binmode('STDOUT');
	print $data while ( read( 'IN', $data, $CHUNK_SIZE ) );
	close IN;
	exit;
}

print &TopOfPage();

if ($P{'todo'} eq 'commandline' or ($cron and !$configerror and !@ARGV))
{
	print &CommandLine();
}
elsif (($P{'todo'} eq 'checkver'))
{
	print &Header('Check for new version of the indexsoft MySQL backups manager');
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=backupsmanager&ver=$VER&r=$nowtime" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0"><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=backupsmanager&ver=$VER&r=$nowtime&method=javascript"></SCRIPT></iframe></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}
elsif (($P{'todo'} eq 'rateus'))
{
	print &Header(qq{Rate indexsoft backups manager at HotScripts.com});
	print qq{<p><form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new"><input type="hidden" name="ID" value="16662"><select name="rate" size="1" style="width: 250px;"><option selected>Select</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form></p><p>&nbsp;</p>};
	print &Header(qq{Rate indexsoft backups manager at ScriptSearch.com});
	print qq{<p><form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new"><input type="hidden" name="ID" value="5691"><select name="rate" size="1" style="width: 250px;"><option value="--">- Select -</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form></p><p>&nbsp;</p>};
	print qq{<p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}
elsif ($P{'todo'} eq 'configure' or $P{'todo'} eq 'saveconfig' or $configerror or $notsaved)
{
	print &Operation('save configuration file') if $P{'todo'} eq 'saveconfig';
	print &HoldError("can not rewrite configuration file <i>'$configfile'</i>") if $notsaved;
	print &EditConfigForm();
}
elsif (($P{'todo'} eq 'packfile') and $P{'file'} and $mySQLDBName)
{
	print &Operation("pack file <i>'$P{'file'}'</i> to <i>'$P{'file'}.$ArchiveExt'</i>");
	$cmd = qq{$ArchiverCommand $TakeErrors};
	$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$P{'file'}.".$ArchiveExt"/ge;
	$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$P{'file'}/ge;
	print '<p>' if !$cron;
	$code = system $cmd;
	print '</p>' if !$cron;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'unpackfile') and $P{'file'} and $mySQLDBName)
{
	print &Operation("unpack file <i>'$P{'file'}'</i>");
	$cmd = qq{$DeArchiverCommand $TakeErrors};
	$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$P{'file'}/ge;
	$cmd =~ s/%p%/$iDBDumpsDir.$DirSeparator/ge;
	print '<p>' if !$cron;
	$code = system $cmd;
	print '</p>' if !$cron;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'ftpfile') and $P{'files'})
{
	print &Operation("upload files to FTP server <i>'$P{'ftpserver'}'</i>");
	grep(push (@files, "$iDBDumpsDir$DirSeparator$_"), split(/\0/, $P{'files'}));
	$code = &FTPFile($P{'ftpserver'}, $P{'ftpport'}, $P{'ftppath'}, $P{'ftplogin'}, $P{'ftppass'}, @files);
	print &HoldError($code) if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'sendfile') and $P{'files'})
{
	print &Operation("send files to <i>'$P{'to'}'</i>");
	grep(push (@files, "$iDBDumpsDir$DirSeparator$_"), split(/\0/, $P{'files'}));
	$code = &SendFile($P{'from'}, $P{'to'}, $P{'subject'}, $P{'body'}, @files);
	print &HoldError("can not send email: <i>'$code'</i>") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'emailform') and $P{'files'} and $mySQLDBName)
{
	$files = '';
	grep($files .= qq{<input type="hidden" name="files" value="$_">} , split(/\0/, $P{'files'}));
	print &Header("Email backup files of database <i>'$mySQLDBName'</i>").qq{
	<p><form action="backupsmanager.cgi" method="post" name="sendform">
	<input type="hidden" name="todo" value="sendfile">
	<input type="hidden" name="db" value="$DB">
	$files
	<i>send message from:</i><br>
	<input type="text" name="from" value="$mySQLDBEmail" size="48" style="width: 320px;"><br>
	<i>send message to:</i><br>
	<input type="text" name="to" value="$mySQLDBEmail" size="48" style="width: 320px;" onclick="if (document.sendform.to.value == '$mySQLDBEmail') { document.sendform.to.value='' };"><br>
	<i>message subject:</i><br>
	<input type="text" name="subject" value="backups of database '$mySQLDBName'" size="48" style="width: 320px;"><br>
	<i>message body:</i><br>
	<textarea cols="38" rows="5" name="body" style="width: 320px;">Check out attachments with backups of database '$mySQLDBName'.</textarea><br><br>
	<input type="submit" value="Send file">
	</form></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>
	};
}
elsif (($P{'todo'} eq 'ftpform') and $P{'files'} and $mySQLDBName)
{
	$files = '';
	grep($files .= qq{<input type="hidden" name="files" value="$_">} , split(/\0/, $P{'files'}));
	print &Header("Upload backups files of database <i>'$mySQLDBName'</i> on FTP server").qq{
	<p><form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="todo" value="ftpfile">
	<input type="hidden" name="db" value="$DB">
	$files
	<i>FTP server:</i><br>
	<input type="text" name="ftpserver" value="$DefaultFTP" size="48" style="width: 320px;"><br>
	<i>FTP server port:</i><br>
	<input type="text" name="ftpport" value="$DefaultFTPPort" size="48" style="width: 320px;"><br>
	<i>path on FTP server:</i><br>
	<input type="text" name="ftppath" value="$DefaultFTPPath" size="48" style="width: 320px;"><br>
	<i>login:</i><br>
	<input type="text" name="ftplogin" value="$DefaultFTPLogin" size="48" style="width: 320px;"><br>
	<i>password:</i><br>
	<input type="password" name="ftppass" value="$DefaultFTPPass" size="48" style="width: 320px;"><br><br>
	<input type="submit" value="FTP file">
	</form></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>
	};
}
elsif (($P{'todo'} eq 'restore') and $P{'filename'} and $mySQLDBName)
{
	print &Operation("restore database <i>'$mySQLDBName'</i> from backup <i>'$P{'filename'}'</i><br><b>disabled in shareware version</b>");
	print &ManageForm();
}
elsif (($P{'todo'} eq 'delete') and $P{'files'} and $mySQLDBName)
{
	print &Operation("delete selected backups");
	foreach $file(split(/\0/, $P{'files'}))
	{
		if (-e "$iDBDumpsDir$DirSeparator$file") { unlink ("$iDBDumpsDir$DirSeparator$file") || print &HoldError("can not delete file <i>'$iDBDumpsDir$DirSeparator$file'</i>") };
	}
	print &ManageForm();
}
elsif (($P{'todo'} eq 'upload') and $P{'uploadfilename'} and $mySQLDBName)
{
	$filehandle = $MULTIPARTQUERY->param('uploadfilename');
	$filename = lc($P{'uploadfilename'});
	$filename =~ s!^.*(\\|\/)!!; 
	print &Operation("upload backup <i>'$filename'</i> for database <i>'$mySQLDBName'</i>");
	open(OUT, ">$iDBDumpsDir$DirSeparator$filename") || print &HoldError("can not save to file <i>'$iDBDumpsDir$DirSeparator$filename'</i>");
	binmode OUT;
	print OUT $buffer while (read($filehandle, $buffer, 1024));
	close OUT;
	print &ManageForm();
}
elsif ($P{'todo'} eq 'backupall')
{
	if (!$P{'filename'}) { $filename = &TextDate(time).'(bulk).sql' } else { $filename = $P{'filename'}; $filename .= '.sql' if $filename !~ '.sql$'; };
	print &Operation("backup all existing databases with filename <i>'$filename'</i><br> ".(($P{'packfile'})?("pack each file to <i>'$filename.$ArchiveExt'</i><br> "):('')).(($P{'emailfile'})?("email files to specified emails<br> "):('')).(($P{'ftpfile'})?("upload them to FTP server <i>'$DefaultFTP'</i><br> "):('')));
	for ($i = 0; $i <= $#mySQLDBName; ++$i)
	{
		&DefineParams($i);
		$cmd = qq{$iDumpDBCommand $TakeErrors >"$iDBDumpsDir$DirSeparator$filename"};
		print '<p>' if !$cron;
		$code = system $cmd;
		print '</p>' if !$cron;
		print &HoldError("command <i>$cmd</i> executed with error") if ($code);
		if ($P{'packfile'} and !$code)
		{
			$cmd = qq{$ArchiverCommand $TakeErrors};
			$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$filename.".$ArchiveExt"/ge;
			$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$filename/ge;
			print '<p>' if !$cron;
			$code = system $cmd;
			print '</p>' if !$cron;
			print &HoldError("command <i>$cmd</i> executed with error") if ($code);
		}
		if ($P{'emailfile'} and !$code)
		{
			$code = &SendFile($mySQLDBEmail, $mySQLDBEmail, "backup of database '$mySQLDBName'", "Check out attachment with backup of database '$mySQLDBName'.", "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
			print &HoldError("can not send email: <i>'$code'</i>") if ($code);
		}
		if ($P{'ftpfile'} and !$code)
		{
			$code = &FTPFile($DefaultFTP, $DefaultFTPPort, $DefaultFTPPath, $DefaultFTPLogin, $DefaultFTPPass, "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
			print &HoldError($code) if ($code);
		}
	}
	&DefineParams($P{'db'});
	print &ManageForm();
}
elsif ($P{'todo'} eq 'dumpandsave' and $mySQLDBName)
{
	if (!$P{'filename'}) { $filename = &TextDate(time).'.sql' } else { $filename = $P{'filename'}; $filename .= '.sql' if $filename !~ '.sql$'; };
	print &Operation("backup database <i>'$mySQLDBName'</i> and save backup to file <i>'$filename'</i>");
	$cmd = qq{$iDumpDBCommand $TakeErrors >"$iDBDumpsDir$DirSeparator$filename"};
	print '<p>' if !$cron;
	$code = system $cmd;
	print '</p>' if !$cron;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	if ($P{'packfile'} and !$code)
	{
		print &Operation("pack file <i>'$filename'</i> to <i>'$filename.$ArchiveExt'</i>");
		$cmd = qq{$ArchiverCommand $TakeErrors};
		$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$filename.".$ArchiveExt"/ge;
		$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$filename/ge;
		print '<p>' if !$cron;
		$code = system $cmd;
		print '</p>' if !$cron;
		print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	}
	if ($P{'emailfile'} and !$code)
	{
		print &Operation("email file <i>'$filename".(($P{'packfile'})?(".$ArchiveExt"):(''))."'</i> to <i>'$mySQLDBEmail'</i>");
		$code = &SendFile($mySQLDBEmail, $mySQLDBEmail, "backup of database '$mySQLDBName'", "Check out attachment with backup of database '$mySQLDBName'.", "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
		print &HoldError("can not send email: <i>'$code'</i>") if ($code);
	}
	if ($P{'ftpfile'} and !$code)
	{
		print &Operation("upload file <i>'$filename".(($P{'packfile'})?(".$ArchiveExt"):(''))."'</i> to FTP server <i>'$DefaultFTP'</i>");
		$code = &FTPFile($DefaultFTP, $DefaultFTPPort, $DefaultFTPPath, $DefaultFTPLogin, $DefaultFTPPass, "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
		print &HoldError($code) if ($code);
	}
	print &ManageForm();
}
else
{
	print &ManageForm();
}

print &BottomOfPage();

#################################################################################
sub ManageForm
{
	return '' if $cron;
	my $filename = &TextDate(time);
	my ($result, $dbselect, $i, @files) = ('','','');
	for ($i = 0; $i <= $#mySQLDBName; ++$i)	{ $dbselect .= qq{<option value="$i"}.(($DB eq $i)?' selected style="background-color: #FFFFFF;">':'>').qq{DB$i: $mySQLDBName[$i] (user $mySQLUser[$i] at $mySQLHost[$i])};}
	my $result = &Header('Select database for maintenance').qq{<p><form name="selectdbform" action="backupsmanager.cgi">
	<select name="db" style="width: 320px; background-color: #E0E0E0;" onchange="selectdbform.submit()">$dbselect</select> 
	<input type="submit" value="select database">
	</form>
	</p>};
	if ($mySQLDBName)
	{
		$result .= &Header("Backup database <i>'$mySQLDBName'</i>").qq{<p><form name="makedbdumpform" action="backupsmanager.cgi" method="post" target="_top">
		<input type="hidden" name="db" value="$DB">
		<ul>
		<li><input type="radio" name="todo" value="dumpanddownload" onclick="document.makedbdumpform.emailfile.disabled = true; document.makedbdumpform.ftpfile.disabled = true; document.makedbdumpform.packfile.disabled = true; document.makedbdumpform.filename.disabled = true; document.makedbdumpform.target = '_top'; "> backup and download it to my computer<br>
		<li><input type="radio" checked name="todo" value="dumpandsave" onclick="document.makedbdumpform.emailfile.disabled = false; document.makedbdumpform.ftpfile.disabled = false; document.makedbdumpform.packfile.disabled = false; document.makedbdumpform.filename.disabled = false; document.makedbdumpform.target = '_self'; "> backup and save it to file: <input type="text" name="filename" value="$filename.sql"><br>
		<input type="checkbox" name="packfile" value="1"> Pack file after saving
		<input type="checkbox" name="emailfile" value="1"> Email file
		<input type="checkbox" name="ftpfile" value="1"> Upload file on FTP server<br>
		</ul>
		<input type="submit" value="Backup">
		</form></p>
		<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
		<!--
		function AreYouSure()
		{
			if (document.selectdbdumpform.todo[0].checked) { return window.confirm('You about to restore database \\'$mySQLDBName\\' from backup.\\nAre you sure?') }
			else { return true; }
		}
		function Boxes(z)
		{
			var frm = document.selectdbdumpform;
			if (z == 'select')
			{
				if (frm.todo[0].checked) { frm.submit.value = '  first select action  ';	frm.submit.disabled = true; }
				frm.todo[0].checked = false; frm.todo[0].disabled = true;
				frm.todo[1].disabled = false; frm.todo[2].disabled = false; frm.todo[3].disabled = false;
				for (var i=0;i<frm.elements.length;i++) { var z=frm.elements[i]; if (z.name == 'filename') { z.checked = false } }
			}
			if (z == 'restore')
			{
				frm.todo[0].checked = true; frm.todo[0].disabled = false;
				frm.todo[1].disabled = true; frm.todo[2].disabled = true; frm.todo[3].disabled = true;
				frm.submit.value = 'Restore from backup'; frm.submit.disabled = false;
				for (var i=0;i<frm.elements.length;i++) { var z=frm.elements[i]; if (z.name == 'files') { z.checked = false } }
			}
			if (z == 'delete') { frm.submit.value = 'Delete backups'; frm.submit.disabled = false; }
			if (z == 'emailform') { frm.submit.value = 'Email backups'; frm.submit.disabled = false; }
			if (z == 'ftpform') { frm.submit.value = 'Upload on FTP'; frm.submit.disabled = false; }
		}
		//-->
		</SCRIPT>}.&Header("Backups list of database <i>'$mySQLDBName'</i>").qq{<p><form name="selectdbdumpform" action="backupsmanager.cgi" method="post" onsubmit="return AreYouSure()">
		<input type="hidden" name="db" value="$DB">
		<ul><li><i>Sel</i> | <i>Res</i> | }.uc("<i>$ArchiveExt</i>");
		opendir (DIR, $iDBDumpsDir); @files = readdir(DIR); closedir(DIR);
		@files = sort @files if $SortDumps;
		foreach  my $file (@files)
		{
			my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$iDBDumpsDir$DirSeparator$file");
			$mtime = TextDateTime($mtime);
			$result .= qq{<li><input type="checkbox" name="files" value="$file" title="select file" onclick="Boxes('select')"> | <input type="radio" name="filename" value="$file" onclick="Boxes('restore')" title=}.(($file =~ /$ArchiveExt$/)?(qq{"disabled for restore. unpack first" disabled> | <input type="radio" name="$file" title="packed file. click to unpack" onclick="this.checked = false; self.location = 'backupsmanager.cgi?todo=unpackfile&file=$file&db=$DB'" checked>}):(qq{"select for restore"> | <input type="radio"  name="$file" title="click to pack file" onclick="self.location = 'backupsmanager.cgi?todo=packfile&file=$file&db=$DB'">})).qq{ | <a target="_top" title="download file" href="backupsmanager.cgi?todo=downloadfile&file=$file&db=$DB&r=$nowtime">$file</a> <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
		}
		$result .= qq{
		</ul>
		<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
		<td width="40%">
		<input type="radio" name="todo" value="restore" disabled> Restore database from backup<br>
		<input type="radio" name="todo" value="delete" onclick="Boxes('delete')" disabled> Delete selected backups
		</td>
		<td>
		<input type="radio" name="todo" value="emailform" onclick="Boxes('emailform')" disabled> Email selected backups<br>
		<input type="radio" name="todo" value="ftpform" onclick="Boxes('ftpform')" disabled> Upload selected backups on FTP server
		</td>
		</tr></table>
		<br>
		<input type="submit" name="submit" value="  first select action  " disabled></form></p>}.&Header("Upload backup for database <i>'$mySQLDBName'</i>").qq{
		<p><form name="uploaddbdumpform" action="backupsmanager.cgi" method="post" enctype="multipart/form-data">
		<input type="hidden" name="db" value="$DB">
		<input type="hidden" name="todo" value="upload">
		<input type="file" name="uploadfilename" size="50">
		<input type="submit" value="Upload">
		</form></p>};
	}
	$result .= &Header('Backup all databases').qq{<p>
	<form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="db" value="$DB">
	<input type="hidden" name="todo" value="backupall">
	<i>filename for backups:</i><br>
	<input type="text" name="filename" value="$filename(bulk).sql" size="47" style="width: 320px;">
	<input type="submit" value="Backup all"><br>
	<input type="checkbox" name="packfile" value="1"> Pack each file after saving
	<input type="checkbox" name="emailfile" value="1"> Email each file
	<input type="checkbox" name="ftpfile" value="1"> Upload each file on FTP server<br>
	</form>
	</p>};
	return $result;
}

sub SendFile
{
	my ($emptyfile) = 'please register indexsoft MySQL backups manager at http://www.indexsoft.com/';
	my ($from, $to, $subject, $body, @files) = @_;
	return $sendmailerror if $sendmailerror;
	$sm = new SendMail($SMTP, $SMTPPort);
	$sm->setDebug($sm->OFF);
	$sm->From($from);
	$sm->Subject($subject);
	$sm->To($to);
	$sm->setMailHeader('X-Mailer', 'indexsoft MySQL backups manager (http://www.indexsoft.com)');
	$body .= "\n\n------------\nSent by indexsoft MySQL backups manager (http://www.indexsoft.com)";
	$body =~ s/\n/\r\n/g;
	$sm->setMailBody("$body");
	grep($sm->Attach("$_.txt", \$emptyfile), @files);
	if ($sm->sendMail() != 0) { return $sm->{'error'} };
	$sm->reset();
	return 0;
}

sub FTPFile
{
	my ($server, $port, $path, $login, $pass, @files) = @_;
	return $ftperror if $ftperror;
	$ftp = Net::FTP->new($server, Debug => 0, Port => $port);
	return $@ if $@;
	$ftp->login($login, $pass);
	return "can not login to <i>'$server'</i>" if !($ftp->pwd());
	$ftp->mkdir("$path/please_register_indexsoft_backups_manager");
	$ftp->cwd("$path/please_register_indexsoft_backups_manager");
	return "can not create directory <i>'please_register_indexsoft_backups_manager'</i> or change remote dir to <i>'please_register_indexsoft_backups_manager'</i>" if ($ftp->pwd() !~ /$path\/please_register_indexsoft_backups_manager/);
	$ftp->quit;
	return 0;
}

sub CommandLine
{
	return q{
Command line switches:
	
--db=x backup database with number x 
--db=all backup all databases

To pack, email and/or upload created backup(s) on FTP server use following switches:
--pack 
--mail 
--ftp

Change default value for old backups:
--old=x delete backups that older then x days

To change default filename(s) for backup(s) file(s) use following switch:
--filename=mycronbackup.sql

To change default SMTP server, its SMTP port and email address use following switches:
--smtpserver=smtp.host.com 
--smtpport=portnumber 
--email=me@email.com

To change default FTP server, its FTP port, path on FTP server, FTP login and password use following switches:
--ftpserver=ftp.host.com 
--ftpport=portnumber 
--ftppath=/myuploads/backups 
--ftplogin=mylogin 
--ftppaswd=mypassword 

All switches can be used simultaneously and in any order for example:

./backupsmanager.cgi --db=all --filename=cron.sql --pack --mail --ftp --ftppaswd=mypass --email=me@host.com

this will backup all databases to 'cron.sql' files, pack them, upload packed files on default FTP server using password 'mypass' and email them all to email address 'me@host.com' using default SMTP settings.

} if $cron;
	my ($dbcmds, $i) = ();
	for ($i = 0; $i <= $#mySQLDBName; ++$i) { $dbcmds .= qq{<li><font face="Courier">--db=$i</font> (backup database '$mySQLDBName[$i]')}; }
	return &Header('Command line parameters').qq{<p>To run indexsoft MySQL backups manager from command prompt (or cron to have scheduled backups for an example) please use following switches:</p>
	<ul>
	$dbcmds
	<li><font face="Courier">--db=all</font> (backup all databases)
	</ul>
	<p>To pack, email and/or upload created backup(s) on FTP server use following switches:</p>
	<ul>
	<li><font face="Courier">--pack</font>
	<li><font face="Courier">--mail</font>
	<li><font face="Courier">--ftp</font>
	</ul>
	<p>Change default value for old backups:</p>
	<ul><li><font face="Courier">--old=x</font> (delete backups that older then x days)</ul>
	<p>To change default filename(s) for backup(s) file(s) use following switch:</p>
	<ul><li><font face="Courier">--filename=mycronbackup.sql</font></ul>
	<p>To change default SMTP server, its SMTP port and email address use following switches:</p>
	<ul>
	<li><font face="Courier">--smtpserver=smtp.host.com</font>
	<li><font face="Courier">--smtpport=portnumber</font>
	<li><font face="Courier">--email=me\@email.com</font>
	</ul>
	<p>To change default FTP server, its FTP port, path on FTP server, FTP login and password use following switches:</p>
	<ul>
	<li><font face="Courier">--ftpserver=ftp.host.com</font>
	<li><font face="Courier">--ftpport=portnumber</font>
	<li><font face="Courier">--ftppath=/myuploads/backups</font>
	<li><font face="Courier">--ftplogin=mylogin</font>
	<li><font face="Courier">--ftppaswd=mypassword</font>
	</ul>
	<p>All switches can be used simultaneously and in any order for example:<br><br>
	<font face="Courier">./backupsmanager.cgi --db=all --filename=cron.sql --pack --mail<br>--ftp --ftppaswd=mypass --email=me\@host.com </font><br><br>	
	this will backup all databases to 'cron.sql' files, pack them, upload packed files on default FTP server using password 'mypass' and email them all to email address 'me\@host.com' using default SMTP settings.</p>
	<p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}

sub EditConfigForm
{
	local *IN;
	my ($cfgfile, $nofile, $result);
	open(IN, "$configfile") || ($nofile = 1);
	grep ($cfgfile .= $_, <IN>);
	close IN;
	$result .= &HoldError($configerror) if ($configerror and !$P{'autocfg'});
	if ($nofile or $P{'autocfg'})
	{
		if ($P{'upgrade'}) { $result .= &Operation('upgrade old version configuration file') }
		else { $result .= &Operation('generate configuration file automatically') }
		$cfgfile = &CfgTemplate();
		if ($cron)
		{
			open(FILE, ">$configfile") || ($result .= &HoldError("can not rewrite configuration file '$configfile'"));
			binmode('FILE');
			print FILE $cfgfile;
			close FILE;
			$result .= "CHECK-UP CONFIGURATION FILE CAREFULLY AND FILL IN ALL INDISPENSABLE VARIABLES\n";
		}
	}
	$result .= &Header('Edit configuration file').qq{
	<ul>
		<li><a href="backupsmanager.cgi?todo=configure&db=$DB&autocfg=1" onclick="return window.confirm('Please confirm the action only if backups manager does not work correctly\\nAre you sure?')">Generate configuration file automatically</a><br></li>
		<li><a href="backupsmanager.cgi?todo=configure&db=$DB&autocfg=1&upgrade=1" onclick="return window.confirm('This action will add new variables to the configuration file if they do not already exist, but it will not overwrite previously defined variables.\\nAre you sure you want to proceed?')">Upgrade old version configuration file</a></li>
	</ul>
	<form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="todo" value="saveconfig">
	<input type="hidden" name="db" value="$DB">
	<textarea cols="66" rows="15" name="cfgfilecontent" wrap="off">$cfgfile</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Save configuration file"></td><td  align="right"><input type="reset" value="Reset all changes"></td></tr></table>
	</form>
	<p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>} if !$cron;
	return $result;
}

sub CfgTemplate
{
my ($result, $i);
my $upg = $P{'upgrade'};

my $installdir = 'NOT_DETECTED';
if ($ENV{'SCRIPT_FILENAME'}) { $installdir = $ENV{'SCRIPT_FILENAME'}; $installdir =~ s/backupsmanager.cgi$//gi; chop $installdir; $installdir =~ s/\//$DirSeparator/g; }

my $dbdumpcmd = 'mysqldump';
if (-e '\mysql\bin\mysqldump.exe') { $dbdumpcmd = '\mysql\bin\mysqldump.exe' }
elsif (-e 'c:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'c:\mysql\bin\mysqldump.exe' }
elsif (-e 'd:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'd:\mysql\bin\mysqldump.exe' }
elsif (-e 'e:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'e:\mysql\bin\mysqldump.exe' }
elsif (-e '\webshare\mysql\bin\mysqldump.exe') { $dbdumpcmd = '\webshare\mysql\bin\mysqldump.exe' }
elsif (-e '/usr/local/bin/mysqldump') { $dbdumpcmd = '/usr/local/bin/mysqldump' }
elsif (-e '/usr/local/mysql/bin/mysqldump') { $dbdumpcmd = '/usr/local/mysql/bin/mysqldump' }
elsif (-e '/usr/mysql/bin/mysqldump') { $dbdumpcmd = '/usr/mysql/bin/mysqldump' }
elsif (-e '/usr/bin/mysqldump') { $dbdumpcmd = '/usr/bin/mysqldump' }
elsif (-e '/usr/local/psa/bin/mysqldump') { $dbdumpcmd = '/usr/local/psa/bin/mysqldump' }
elsif (-e '/usr/local/psa/mysql/bin/mysqldump') { $dbdumpcmd = '/usr/local/psa/mysql/bin/mysqldump' };

my $dbrestcmd = 'mysql';
if (-e '\mysql\bin\mysql.exe') { $dbrestcmd = '\mysql\bin\mysql.exe' }
elsif (-e 'c:\mysql\bin\mysql.exe') { $dbrestcmd = 'c:\mysql\bin\mysql.exe' }
elsif (-e 'd:\mysql\bin\mysql.exe') { $dbrestcmd = 'd:\mysql\bin\mysql.exe' }
elsif (-e 'e:\mysql\bin\mysql.exe') { $dbrestcmd = 'e:\mysql\bin\mysql.exe' }
elsif (-e '\webshare\mysql\bin\mysql.exe') { $dbrestcmd = '\webshare\mysql\bin\mysql.exe' }
elsif (-e '/usr/local/bin/mysql') { $dbrestcmd = '/usr/local/bin/mysql' }
elsif (-e '/usr/local/mysql/bin/mysql') { $dbrestcmd = '/usr/local/mysql/bin/mysql' }
elsif (-e '/usr/mysql/bin/mysql') { $dbrestcmd = '/usr/mysql/bin/mysql' }
elsif (-e '/usr/bin/mysql') { $dbrestcmd = '/usr/bin/mysql' }
elsif (-e '/usr/local/psa/bin/mysql') { $dbrestcmd = '/usr/local/psa/bin/mysql' }
elsif (-e '/usr/local/psa/mysql/bin/mysql') { $dbrestcmd = '/usr/local/psa/mysql/bin/mysql' };

my $archivercmd = 'NOT_DETECTED';
my $archiveext = 'NOT_DETECTED';
my $dearchivercmd = 'NOT_DETECTED';
if ($ENV{'WINDIR'})
{
	if (-e 'c:\program files\winrar\rar.exe')
	{
		$archivercmd = '"c:\program files\winrar\rar.exe" a -inul -df -y -ep "%a%" "%f%"';
		$dearchivercmd = '"c:\program files\winrar\rar.exe" e -inul -y "%a%" %p%';
		$archiveext = 'rar';
	}
}
else
{
	$archivercmd = 'gzip -9 -q -f "%f%"';
	$dearchivercmd = 'gunzip -q -f "%a%"';
	$archiveext = 'gz';
}


$result = q{# ATTENTION!!! AUTOMATICALLY GENERATED CONFIGURATION FILE
# PLEASE CHECK-UP CAREFULLY AND FILL IN ALL INDISPENSABLE VARIABLES
# if some of executables files was not detected automatically, you can use
# free indexsoft files searcher to find them fast and easy
# check downloads page at http://www.indexsoft.com/

# arrays @mySQLDBName, @mySQLHost, @mySQLUser and @mySQLPassword
# contains lists of MySQL databases, MySQL hosts, MySQL users
# and their passwords accordingly
# @mySQLDBEmail used for send DB backups individually
};

if (($#mySQLDBName >= 0) and $upg)
{
for ($i = 0; $i <= $#mySQLDBName; ++$i) 
{
$result .= qq{
\$mySQLDBName[$i] = '$mySQLDBName[$i]';
\$mySQLHost[$i] = '$mySQLHost[$i]';
\$mySQLUser[$i] = '$mySQLUser[$i]';
\$mySQLPassword[$i] = '$mySQLPassword[$i]';
\$mySQLDBEmail[$i] = '$mySQLDBEmail[$i]';\n}
}
}
else
{
$result .= q{
$mySQLDBName[0] = 'mydb0';
$mySQLHost[0] = 'localhost';
$mySQLUser[0] = 'root';
$mySQLPassword[0] = '';
$mySQLDBEmail[0] = '';

# if you whant to backup ALL databases you can use --all-databases as DB name:
#$mySQLDBName[1] = '--all-databases';
#$mySQLHost[1] = 'localhost';
#$mySQLUser[1] = 'root';
#$mySQLPassword[1] = '';
#$mySQLDBEmail[1] = '';}
}

$result .= q{

# complete path to directory to store DBs backups, leave out trailing "\\" or "/"
$DBDumpsDir = '}.(($DBDumpsDir and $upg)?("$DBDumpsDir"):("$installdir$DirSeparator".'dumps')).q{';

# sort backups file alphabeticaly. Do not sort files if $SortDumps is empty or 0 (zero)
$SortDumps = '}.(($SortDumps and $upg)?("$SortDumps"):('0')).q{';

# full path and a name of the executable file which is delivered with distribution
# of MySQL DB server and which makes a DB dumps
# if you do not know path to this file you can download from somewhere binary for your system,
# upload it with backups manager and type here path and name
$DumpDBCommand = '}.(($DumpDBCommand and $upg)?("$DumpDBCommand"):("$dbdumpcmd")).q{';

# additional options for mysqldump. space delimited
# for full lists of options see http://www.mysql.com/doc/en/mysqldump.html
$DumpDBOptions = '}.(($DumpDBOptions and $upg)?("$DumpDBOptions"):('--quote-names --add-drop-table')).q{';

# full path and a name of the executable file which restore database
# if you do not know path to this file you can download from somewhere binary for your system,
# upload it with backups manager and type here path and name
$RestoreDBCommand = '}.(($RestoreDBCommand and $upg)?("$RestoreDBCommand"):("$dbrestcmd")).q{';

# additional options for mysql. space delimited
# for full lists of options see http://www.mysql.com/doc/en/mysql.html
$RestoreDBOptions = '}.(($RestoreDBOptions and $upg)?("$RestoreDBOptions"):('')).q{';

# backups manager can display error if it occured while running external programs
# this work only with *nix and any Windows NT system
# set $TakeErrors to 0 (zero) if you use windows 9x or ME
$TakeErrors = '}.((defined $TakeErrors and $upg)?("$TakeErrors"):('1')).q{';

# backups manager can automatically delete old backups. files older then $OldBackups (in days) will be deleted
# 0 means do not delete backups
$OldBackups = '}.(($OldBackups and $upg)?("$OldBackups"):('0')).q{';

# full path (if required) and name of the archiver
# %f% - defines filename to pack, %a% - defines filename of archive
# for example (WinRAR usage under Windows):
# $ArchiverCommand = '"c:\program files\winrar\rar.exe" a -df -inul -ep -y "%a%" "%f%"';
# for example (gzip on *nix):
# $ArchiverCommand = 'gzip -9 -q -f "%f%"' or 'gzip -9 -q -f -c "%f%" > "%a%"';
$ArchiverCommand = '}.(($ArchiverCommand and $upg)?("$ArchiverCommand"):("$archivercmd")).q{';

# full path (if required) and name of the dearchiver
# %p% - path to extract, %a% - defines filename of archive
# for example (WinRAR usage under Windows):
# $DeArchiverCommand = '"c:\program files\winrar\rar.exe" e -inul -y "%a%" %p%';
# for example (gzip on *nix):
# $DeArchiverCommand = 'gunzip -q -f "%a%"';
$DeArchiverCommand = '}.(($DeArchiverCommand and $upg)?("$DeArchiverCommand"):("$dearchivercmd")).q{';

# file extension for archives, for example: 'gz' if *nix gzip or 'rar' if winar
$ArchiveExt = '}.(($ArchiveExt and $upg)?("$ArchiveExt"):("$archiveext")).q{';

# default email address to send DB backups
$DefaultEmail = '}.(($DefaultEmail and $upg)?("$DefaultEmail"):("$ENV{'SERVER_ADMIN'}")).q{';

# SMTP server for sending email (default - localhost). indexsoft backups manager uses
# SendMail.pm (http://www.tneoh.zoneit.com/perl/SendMail/) to send email
# if SendMail.pm can not connect to SMTP host you can use patched SendMail.pm, wich can use a program
# to send emails (for example sendmail for linux). In this case type in here command line and parameters
# of a program (for example to use linux sendmail: $SMTP = '|/usr/sbin/sendmail -t');
$SMTP = '}.(($SMTP and $upg)?("$SMTP"):('localhost')).q{';

# SMTP port (default 25)
$SMTPPort = '}.(($SMTPPort and $upg)?("$SMTPPort"):('25')).q{';

# default FTP server
$DefaultFTP = '}.(($DefaultFTP and $upg)?("$DefaultFTP"):('localhost')).q{';

# default FTP server port
$DefaultFTPPort = '}.(($DefaultFTPPort and $upg)?("$DefaultFTPPort"):('21')).q{';

# default path on FTP server, leave out trailing "/"
$DefaultFTPPath = '}.(($DefaultFTPPath and $upg)?("$DefaultFTPPath"):('/upload')).q{';

# default login to access FTP server
$DefaultFTPLogin = '}.(($DefaultFTPLogin and $upg)?("$DefaultFTPLogin"):('ftp')).q{';

# default password to access FTP server
$DefaultFTPPass = '}.(($DefaultFTPPass and $upg)?("$DefaultFTPPass"):('ftp@mydomain.com')).q{';

1; # DO NOT DELETE THIS LINE
};
return $result;
}

sub DefineParams
{
	($DB, $mySQLDBName, $mySQLHost, $mySQLUser, $mySQLPassword, $iDumpDBCommand, $iRestoreDBCommand, $iDBDumpsDir) = ();
	($TakeErrors)?($TakeErrors = '2>&1'):($TakeErrors);
	mkdir ($DBDumpsDir, 0777) if (!-e $DBDumpsDir);
	$DB = $_[0];
	return if $DB !~ /^\d+$/;
 	$mySQLDBName = $mySQLDBName[$DB];
	$mySQLHost = $mySQLHost[$DB];
	$mySQLUser = $mySQLUser[$DB];
	$mySQLPassword = $mySQLPassword[$DB];
	($mySQLDBEmail[$DB])?($mySQLDBEmail = $mySQLDBEmail[$DB]):($mySQLDBEmail = $DefaultEmail);
	$iDumpDBCommand = "$DumpDBCommand $DumpDBOptions --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword $mySQLDBName";
	$iRestoreDBCommand = "$RestoreDBCommand $RestoreDBOptions --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword $mySQLDBName";
	$iDBDumpsDir = "$DBDumpsDir$DirSeparator$mySQLHost---$mySQLDBName";
	mkdir ($iDBDumpsDir, 0777) if ($mySQLDBName and !-e $iDBDumpsDir);
	if ($Old and $mySQLDBName)
	{
		my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks,$file) = ();
		opendir (DIR, $iDBDumpsDir);
		while ($file = readdir(DIR))
		{
			($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$iDBDumpsDir$DirSeparator$file");
			if ($file ne '.' and $file ne '..' and $nowtime - $ctime > $Old) { unlink ("$iDBDumpsDir$DirSeparator$file") }
		}
		closedir(DIR);
	}
}

sub TopOfPage
{
	$cron
	? return "indexsoft MySQL backups manager (ver. $VER)\nstarted at ".&TextDateTime(time)."\n"
	: return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft MySQL backups manager (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 10px; margin-bottom : 10px; }
		form { margin-top : 10px; margin-bottom : 10px; }
		H4 { color : #5588BB; font-size : 16px;}
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
		body .small2 { font-size : 11px; text-align: left;}
	</style>
	</head>
	
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft MySQL backups manager</h4>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>};
}

sub BottomOfPage
{
	$cron
	? return 'stoped at '.&TextDateTime(time)."\n"
	: return qq{</td></tr></table></td></tr></table><div class=small><a href="https://secure.shareit.com/shareit/cart.html?PRODUCT[159818]=1&CPRODUCT[161010]=Y&languageid=1&nolselection=1&currencies=all&backlink=http%3A%2F%2Fwww.indexsoft.com%2Fbuynow.px&cookies=1">register</a> | <a href="backupsmanager.cgi?todo=configure&db=$DB">configuration file</a> | <a href="backupsmanager.cgi?todo=commandline&db=$DB">command line</a> | <a href="backupsmanager.cgi?todo=checkver&db=$DB">check for new version</a> | <a href="backupsmanager.cgi?todo=rateus&db=$DB">rate us</a> | <a href="mailto:mlist\@indexsoft.com?subject=subscribe4">indexsoft news</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div>
		<p><font size="1">[ note: some features are disabled in shareware version. please register your copy to get advantages of the full version ]</font></p>
		</td></tr></table></body></html>};
}

sub Operation
{
	my ($operation) = @_;
	$cron
	? do { $operation =~ s/<[^<>]*>//g; return "Action: $operation\n" }
	: return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$operation</td></tr></table></td></tr></table><br>};
}

sub Header
{
	$cron
	? return ''
	: return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table><br>};
}

sub HoldError
{
	my ($error) = @_;
	$cron
	? do { $error =~ s/<br>/\n/g; $error =~ s/<[^<>]*>//g; return "Error: $error\n" }
	: return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$error</td></tr></table></td></tr></table><br>};
}

sub TextDate
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	$year = 1900+$year;
	++$mon;
	if (length($mon)==1) {$mon="0$mon"};
	if (length($mday)==1) {$mday="0$mday"};
	$_ = "$year-$mon-$mday";
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ('January', 'February', 'March', 'April', 'May', 'June', 'Jule', 'August', 'September', 'October', 'November', 'December');
	if (length($hour)==1) {$hour="0$hour"};
	if (length($min)==1) {$min="0$min"};
	if (length($sec)==1) {$sec="0$sec"};
	$year = 1900+$year;
	$_ = "$mday $mons[$mon] $year; $hour\:$min\:$sec";
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
}

sub ReadArgv
{
	my ($line) = ();
	foreach $line(@ARGV)
	{
		# --db=1(2...)
		if ($line =~ '^--db=(\d+)$') { $P{'db'} = $1; $P{'todo'} = 'dumpandsave'; }
		# --db=all
		elsif ($line =~ '^--db=all$') { $P{'todo'} = 'backupall'; }
		# --pack
		elsif ($line =~ '^--pack$') { $P{'packfile'} = 1; }
		# --mail
		elsif ($line =~ '^--mail$') { $P{'emailfile'} = 1; }
		# --email=email@mmmm.com
		elsif ($line =~ '^--email=(.*)$') { $DefaultEmail = $1; }
		# --smtpserver=server
		elsif ($line =~ '^--smtpserver=(.*)$') { $SMTP = $1; }
		# --smtpport=port
		elsif ($line =~ '^--smtpport=(\d+)$') { $SMTPPort = $1; }
		# --ftp
		elsif ($line =~ '^--ftp$') { $P{'ftpfile'} = 1; }
		# --ftpserver=server
		elsif ($line =~ '^--ftpserver=(.*)$') { $DefaultFTP = $1; }
		# --ftpport=port
		elsif ($line =~ '^--ftpport=(\d+)$') { $DefaultFTPPort = $1; }
		# --ftppath=path
		elsif ($line =~ '^--ftppath=(.*)$') { $DefaultFTPPath = $1; }
		# --ftplogin=login
		elsif ($line =~ '^--ftplogin=(.*)$') { $DefaultFTPLogin = $1; }
		# --ftppaswd=password
		elsif ($line =~ '^--ftppaswd=(.*)$') { $DefaultFTPPass = $1; }
		# --filename=filename
		elsif ($line =~ '^--filename=(.*)$') { $P{'filename'} = $1; }
		# --old=x
		elsif ($line =~ '^--old=(\d+)$') { $OldBackups = $1; }
	}
}
